PROGRAM	      = pl0.x
DEST	      = .
CC	      = gcc
CFLAGS	      = -O
#CFLAGS	      = -O -DNO_TWENTYONE
LDFLAGS	      = -O
RIE	      = rie
LEX	      = flex
#EXTHDRS	      =	/usr/include/stdio.h \
#		/usr/include/string.h \
#		/usr/include/malloc.h
HDRS	      = common.h \
		env.h \
		code.h
ANAS	      = pl0.rie \
		pl0.l
SRCS	      = common.c \
		env.c \
		code.c \
		inter.c \
		lex.c
MDMS	      = pl0.tab.c \
		lex.yy.c \
		pl0.tab.h
OBJS	      = pl0.tab.o \
		lex.yy.o \
		common.o \
		env.o \
		code.o \
		inter.o

pl0:		$(OBJS)
		$(CC) $(LDFLAGS) $(OBJS) -o pl0
pl0.tab.o:	pl0.tab.c env.h code.h
		$(CC) $(CFLAGS) -c pl0.tab.c -o pl0.tab.o
#pl0.tab.o:	pl0_tab.c env.h code.h
#		$(CC) $(CFLAGS) -c pl0_tab.c -o pl0_tab.o
pl0.tab.h \
pl0.tab.c:	pl0.rie
		$(RIE) -d pl0.rie
#pl0_tab.h \
#pl0_tab.c:	pl0.rie
#		$(RIE) -d pl0.rie
lex.yy.o:	lex.yy.c
		$(CC) $(CFLAGS) -c lex.yy.c -o lex.yy.o
#lex.yy.o:	lex_yy.c
#		$(CC) $(CFLAGS) -c lex_yy.c -o lex_yy.o
lex.yy.c:	pl0.l lex.c
		$(LEX) pl0.l
#lex_yy.c:	pl0.l lex.c
#		$(LEX) pl0.l
lex.c:		env.h code.h pl0.tab.h
#lex.c:		env.h code.h pl0_tab.h
common.o:	common.c
		$(CC) $(CFLAGS) -c common.c -o common.o
env.o:		env.c
		$(CC) $(CFLAGS) -c env.c -o env.o
env.c:		env.h
env.h:		common.h
code.o:		code.c code.h common.h
		$(CC) $(CFLAGS) -c code.c -o code.o
code.c:		code.h common.h
inter.o:		inter.c code.h
		$(CC) $(CFLAGS) -c inter.c -o inter.o

#
clean:;		rm -f $(PROGRAM) $(MDMS) $(OBJS) core

tags:		$(MDRS)
		etags $(HDRS) $(ANAS) $(SRCS)

comp:;		@compress -v $(HDRS) $(ANAS) $(SRCS)

uncomp:;	@uncompress -v $(HDRS) $(ANAS) $(SRCS)
