/* ---------------------- env.h ----------------------- */
#include "common.h"

	/* global constants for environment */
#define LEVMAX		3
#define AMAX		2047
#define TXMAX		100
#define SENTINEL	&table[0]

	/* dada type of environment */
typedef char *string;

typedef enum { CONSTANT, VARIABLE, PROC } idtype;

typedef struct { /* an entry of the symbol table */
    char *name;  /* name string */
    idtype kind; /* indicates constant, variable, or procedure */
    int val;     /* value of a constant */
    int level;   /* level of a variable or procedure */
    int adr;     /* displacement (offset), if it is a variable, 
                    start label of the code, if it is a procedure */
} tblstr, *tblptr; 

typedef struct{  /* this is the type of attributes I_env and S_env */
    int lev;     /* static nesting level */
    int dx;      /* current displacement (offset). starts from 3. */
    tblptr cur;  /* points to the beginning of current-level environment */
    tblptr top;  /* points to the end of current-level environment */
} envstr, *envptr;

extern tblstr table[]; /* the symbol table in an array */

extern envptr allocenv();
extern envptr nullenv();
extern envptr newenv();
extern envptr enter();
extern tblptr lookup();
extern bool   exist();
extern envptr printenv();
