/* ----------------------------- lex.c ------------------------------ */
	/* input and output functions, which overwrites original one. */
#include "env.h"
#include "code.h"
#if ( defined( __human68k__) && ( NO_TWENTYONE))
#include "pl0_tab.h"
#else
#include "pl0.tab.h"
#endif
#undef yywrap
#define yywrap() TRUE

extern FILE *yyin, *yyout;
extern char yysbuf[];
extern char *yysptr;
extern int yytchar;
extern int yylineno;

#ifdef input		/* if not flex but lex is used as lexical analyzer. */
#undef  ECHO		/* force ECHO to do nothing */
#define ECHO

#undef input 
int input()
{
    if( yysptr > yysbuf ) {
	yytchar = (int)*--yysptr;
    } else {
	yytchar = yygetc( yyin );
    }
    switch( yytchar ) {
    case (int)'\n':
	yylineno++;
	break;
    case EOF:
	yytchar = (int)'\0';
	break;
    }
    return yytchar;
}

#undef unput 
void unput( c )
  char c;
{
    yytchar = c;
    if( yytchar == '\n' )
	yylineno--;
    *yysptr++ = yytchar;
}

#undef output   
int output( c )
  char c;
{
    return putc( c, yyout );
}

static char buf[512] = "\0";
static char *ptr = buf;
static unsigned int linenum = 1;

int yygetc( fin )		/* get one buffered character */
  FILE *fin;
{
    register char *p;

    if( *ptr == '\0' ) {
	for( p = ptr = buf; (*p=(char)getc(fin)) != '\n' && *p != EOF; p++ );
	*++p = '\0';
	if( yyout != NULL && buf[0] != EOF ) {
	    (void)fprintf( yyout, "%4d: %s", linenum++, buf );
	}
    }
    return (int)*ptr++;
}
#endif
