/* Allocate and clear storage for bison,
   Copyright (C) 1984, 1989 Free Software Foundation, Inc.

This file is part of Bison, the GNU Compiler Compiler.

Bison is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Bison is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bison; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


#include <stdio.h>

#ifndef __human68k__
extern char *calloc();  /*  calloc, malloc in XC libraly is not work well.*/
#endif                  /*  so I used GNU malloc. */
#ifdef LIBC_X68K
extern char *calloc();  /* in case of to use "libc" libraly. it has useful malloc. */
#endif
extern char *realloc ();
extern void done ();

extern char *program_name;

char *
xmalloc (n)
     register unsigned n;
{
  register char *block;

  /* Avoid uncertainty about what an arg of 0 will do.  */
  if (n == 0)
    n = 1;
#ifdef __human68k__
#ifndef LIBC_X68K
{   
register unsigned i;

  block = (char *) malloc(n);        /* replacement of calloc() */
  for (i=0;i<n;i++) *(block+i)=0;
};
#else
  block = calloc (n, 1);
#endif
#else
  block = calloc(n, 1);
#endif  
  if (block == NULL)
    {
      fprintf (stderr, "%s: memory exhausted\n", program_name);
      done (1);
    }

  return (block);
}

char *
xrealloc (block, n)
     register char *block;
     register unsigned n;
{
  /* Avoid uncertainty about what an arg of 0 will do.  */
  if (n == 0)
    n = 1;
  block = realloc (block, n);
  if (block == NULL)
    {
      fprintf (stderr, "%s: memory exhausted\n", program_name);
      done (1);
    }

  return (block);
}
