/* Attribute definitions
   Copyright (C) 1991-1993 Masataka Sassa, Kazuhiro Kuroishi, Teruhisa Hirai.
   Copyright (C)      1994,1995                              Yoshiki Ohshima.
     
This file is part of Rie, A Compiler Compiler Based on ECLR-attributed Grammar.

Rie is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Rie is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bison; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

Bug reports, fixes or ideas are welcomed.
		Address: Yoshiki Ohshima
			 Tokyo Institute of Technology,
			 Department of Information Science,
			 Ookayama, Meguro-ku, Tokyo, 152 Japan.

		E-mail: rie-comments@is.titech.ac.jp			*/

#ifndef _PURE_H
#define _PURE_H

/*  attribute classes  */

#define AUNKNOWN	0  /*  unknown     attribute  */
#define INHERIT		1  /*  inherited   attribute  */
#define SYNTHESIZE	2  /*  synthesized attribute  */
#define LOCAL		3  /*  local attribute        */

/*  undefined ECstack  */

#define EC_UNDEF	-1


typedef
  struct pure
    {	
      char *name;
      char *type;
      short class;
      short EC;
#ifdef DEBUG
      int no;
#endif	
    }
  pure;


typedef
  struct pure_list
    {
      struct pure_list *link;

      pure *pure;
    }
  pure_list;


#endif /* _PURE_H */

